<?php
/**
 * @filename DefaultFactory.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2020/12/17 14:48
 */


namespace JerryYan\DSL\Token\Factory;


use JerryYan\DSL\Token\Token;
use JerryYan\DSL\Token\TokenCurry;
use JerryYan\DSL\Token\TokenDefine;
use JerryYan\DSL\Token\TokenFake;
use JerryYan\DSL\Token\TokenLogicAnd;
use JerryYan\DSL\Token\TokenLogicEqual;
use JerryYan\DSL\Token\TokenLogicFake;
use JerryYan\DSL\Token\TokenLogicGreater;
use JerryYan\DSL\Token\TokenLogicLess;
use JerryYan\DSL\Token\TokenLogicNot;
use JerryYan\DSL\Token\TokenLogicNotEqual;
use JerryYan\DSL\Token\TokenLogicOr;
use JerryYan\DSL\Token\TokenNumber;
use JerryYan\DSL\Token\TokenUseVariable;
use JerryYan\DSL\Token\TokenVariable;

class DefaultFactory extends FactoryInterface
{
    protected $tokenMap = [
        Token::FAKE => TokenFake::class,
        Token::CURRY => TokenCurry::class,
        Token::LOGIC_AND => TokenLogicAnd::class,
        Token::LOGIC_OR => TokenLogicOr::class,
        Token::LOGIC_NOT => TokenLogicNot::class,
        Token::LOGIC_EQUAL => TokenLogicEqual::class,
        Token::LOGIC_NOT_EQUAL => TokenLogicNotEqual::class,
        Token::LOGIC_GREATER => TokenLogicGreater::class,
        Token::LOGIC_LESS => TokenLogicLess::class,
        Token::LOGIC_FAKE => TokenLogicFake::class,
        Token::VARIABLE => TokenVariable::class,
        Token::NUMBER => TokenNumber::class,
        Token::DEFINE => TokenDefine::class,
        Token::USE_VARIABLE => TokenUseVariable::class,
    ];

    protected $undefinedTokenClass = TokenVariable::class;
}